clear
format compact
format long e
global A D counter mults SHIFTA ;
A=sparse(A);
D=sparse(D);
dgaptol=1e-9;

N = 32 ;
n = N*N ;
e = ones(n,1) ;
d = e ;
for i = N:N:n
    d(i) = 0 ;
end

A = spdiags([ -e -d 2*e ], [-N -1 0 ], n , n) ;
A = (A+A')  - 5*speye(n) ;
b = rand(n,1) ;

r   = 100 ;
tmults = 0 ;
tcounter = 0 ;             
avecount = 0 ;             
titers = 0 ;             
aveiters = 0 ;             
viters = 0 ;             
itermax = 0 ;             
for it = 1:20
    b = rand(n,1) ;
    A=sparse(A);
    D=sparse(D);
    [xopt,fopt,lopt,lambdamin,muup,mulow,iter,flag] = ...
                  newtrust(b,r,dgaptol);
    relfeasxopt(it)=abs(1-norm(xopt)/r);
    reloptcond(it)=-norm(  (A-lopt* eye(size(A,1)) )*xopt-b )/fopt;
    absoptcond(it)=-norm(  (A-lopt* eye(size(A,1)) )*xopt-b );
    mults
    xopt = xopt*(r/norm(xopt)) ;
    t = b - A*xopt ;
    mu = t'*xopt/(r^2) ;
    err(it) = norm(t-xopt*mu);
    tmults = tmults + mults ;
    tcounter=tcounter+counter;    
    titers=titers+iter;    
    viters(it)=iter;   
    if iter > itermax,
       save xprb1 A r b dgaptol viters
       itermax=iter;
    end
end
avemults = tmults/20;
avecount=tcounter/20;
!rm prb1.diary
diary prb1.diary
disp('average of matrix multiplications')
[avecount]
disp('average of iterations')
[sum(viters)/length(viters)]
disp('individual iterations per problem')
[viters]
disp('relative feasibility for each problem')
[relfeasxopt]
disp('absol. optimality error for each problem')
[absoptcond]
disp('relative optimality error for each problem')
[reloptcond]
diary off
