function [x0] = initialize(n,prob)

% This function initializes x0 for the trust region method depending on the
% problem considered
%
% n is the problem size
% prob is the problem number (refer to objective.m)
%



if prob == 1

  x0 = -1*ones(n,1);

end

if prob == 2

  x0 = 1/(n+1)*[1:n]';

end

if prob == 3

  x0 = 1/n*[1:n]';

end

if prob == 4

  div = n/4;

  for k=1:div
    x0(4*k-3) = 3;
    x0(4*k-2) = -1;
    x0(4*k-1) = 0;
    x0(4*k)   = 1;
  end

  x0 = x0';

end

if prob == 5

  x0 = 1/(n+1)*[1:n]';

end

if prob == 6

  x0 = ones(n,1);

end

if prob == 7
 
  x0 = zeros(n,1);

end

if prob == 8

  for i=1:n
    x0(i) = (i*(i-n-1))/(n+1)^2;
  end

  x0 = x0';

end

if prob == 9

  x0 = -1*ones(n,1);

end

if prob == 10

  x0 = zeros(n,1);

end

if prob == 11

  x0 = 0.5*ones(n,1);

end

if prob == 12

  x0 = ones(n,1);

end

if prob == 13

  x0 = ones(n,1);

end

if prob == 14

  x0 = ones(n,1);

end

if prob == 15

  x0 = zeros(n,1);
  x0(n) = 3/2;

end

if prob == 16

  x0 = zeros(n,1);

end

if prob == 17

  for i=1:n/2
     x0(2*i-1) = 2*i;
     x0(2*i) = 2*i;
  end

  x0 = x0';

end